import time, os, sys, random, threading

from ReplicatedFile import File

if __name__=="__main__":
    directory = os.path.split(sys.argv[0])[0]
else:                    
    directory = os.path.split(__file__)[0]

running = 1

def do(prefix,lock):
    f1 = File(os.path.join(directory,'source',prefix+'1'),'w+b')
    t = [None,None,None,None]
    tnames = [prefix+'t1',prefix+'t2',prefix+'t3',prefix+'t4']
    while running:
        # delete a random file
        tnumber = random.randint(0,3)
        if t[tnumber]:
            t[tnumber].unlink()
            t[tnumber] = None
        # rename a random file
        a = random.randint(0,3)
        b = random.randint(0,3)
        if t[a] and a!=b:
            t[a].rename(os.path.join(directory,'source',tnames[b]))
            t[b] = t[a]
            t[a] = None
        # write loads of stuff
        tnumber = random.randint(0,3)
        f2 = t[tnumber]
        if f2 is None:
            f2 = t[tnumber] = File(os.path.join(directory,'source',tnames[tnumber]),'w+b')
        for i in range(5):
            f1.seek(1000)
            f2.seek(random.randint(0,10240))
            f2.truncate()
            for i in range(15):
                c = random.choice('abcdefghijkl')
                #time.sleep(0.01)
                f1.write(c*1000)
                f2.write(c*random.randint(0,10240))
        try:
            f2.fsync()
        except:
            print 'waaaaaaaaaaaaaah! no fsync'
    lock.release()

locks = []
for c in 'ab':
    lock = threading.Lock()
    lock.acquire()
    locks.append(lock)
    thread = threading.Thread(target=do,args=(c,lock))
    thread.start()
time.sleep(3600)
running = 0
for lock in locks:
    lock.acquire()
